/**
 * Copyright (c) 2024 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "display/color.h"

#define FRAME_CHAR_SIZE 8
#define FRAME_PIXEL_WIDTH 320
#define FRAME_PIXEL_HEIGHT 240
#define FRAME_WIDTH FRAME_PIXEL_WIDTH/FRAME_CHAR_SIZE
#define FRAME_HEIGHT FRAME_PIXEL_HEIGHT/FRAME_CHAR_SIZE

#define FRAME_BOTTOM_UI_HEIGHT 8

#define FRAME_MAP_WIDTH FRAME_WIDTH
#define FRAME_MAP_HEIGHT (FRAME_HEIGHT - FRAME_BOTTOM_UI_HEIGHT)

extern char_t FRAME_BUFFER[FRAME_HEIGHT * FRAME_WIDTH];
extern uint8_t FRAME_COLOR[FRAME_HEIGHT * FRAME_WIDTH];

/**
 * Initializes the frame buffer.
 */
void frameInit();

/**
 * Updates the terminal frame.
 */
void frameUpdate();

/**
 * Draws the paused screen.
 */
void framePausedDraw();

/**
 * Resets the UI area of the frame.
 */
void frameUIReset();

/**
 * Redraws the entire map area of the frame.
 */
void frameMapDraw();